#include<stdio.h>
#include<stdlib.h>
#include<string.h>

FILE *Ziel;
FILE *Quell;
//FILE *Debug;
long int fp,PolyCount;
char Base32=0;
double Faktor=1;



struct PolyBuf
 {
 long int x;
 long int y;
 } PolyBuf[4000];

long int altx,alty,neux,neuy;
char pen=1,Relative=0,PenDown=0,spur=0;

void Init()
 {
 pen=1;
 Relative=0;
 PenDown=0;
 spur=0;
 }


void Linie(long int x1, long int y1,long int x2,long int y2)
 {
 long int xq,yq,xz,yz;
 double d;
 d=x1*Faktor; xq=d;
 d=y1*Faktor; yq=d;
 d=x2*Faktor; xz=d;
 d=y2*Faktor; yz=d;
 fprintf(Ziel,"L%d %ld %ld %ld %ld\n",pen,xq,yq,xz,yz);
 }



char OptPar()	//Koordinatenpaerchen holen...
 {
 unsigned char ch,st1[40],a=0,sec=0;
 long int tempx,tempy;

 do
  {
  ch=getc(Quell);
  if((isdigit(ch))||(ch=='-')||(ch=='.'))
   {
   st1[a]=ch;
   a++;
   }
  if(ch==',')
   {
   st1[a]=0;
   if(sec)
    {
    tempy=atol(st1);
    sec=0;

    if(!Relative)
     {
     neux=0;
     neuy=0;
     }
    neux+=tempx;
    neuy+=tempy;
    if(PenDown)
     {
     Linie(altx,alty,neux,neuy);
     spur=0;
     }
    altx=neux;
    alty=neuy;
    }
   else
    {
     tempx=atol(st1);
     sec=1;
    }
   a=0;
   }
  }
  while((!isalpha(ch))&&(!feof(Quell)));
  //letztes Paerchen
  if(a&&sec) //noch was in Y
   {
    st1[a]=0;
    tempy=atol(st1);
    if(!Relative)
     {
     neux=0;
     neuy=0;
     }
    neux+=tempx;
    neuy+=tempy;
    if(PenDown)
     {
      Linie(altx,alty,neux,neuy);
      spur=0;
     }
    altx=neux;
    alty=neuy;
   }
  return(ch);
 }



long int ReadPar(signed long int Z1)
 {
 signed long int Schieber,Zaehler,inchar;
 unsigned char ch=0;

  Zaehler=0;
  Schieber=0;
 if(Base32)
 {
  do
   {
   if(!Z1) ch=getc(Quell);
   else {ch=Z1; Z1=0;}
   inchar=ch;
   if(ch>94)        //letztes
    {
    inchar-=95;
    inchar=inchar<<Schieber;
    Zaehler+=inchar;
    }
   else
    {
    inchar-=63;
    inchar=inchar<<Schieber;
    Zaehler+=inchar;
    }
   Schieber+=5;
   }
  while(ch<95);
 }
 else
 {
  do
   {
   if(!Z1) ch=getc(Quell);
   else {ch=Z1; Z1=0;}
   inchar=ch;
   if(ch>190)        //letztes
    {
    inchar-=191;
    inchar=inchar<<Schieber;
    Zaehler+=inchar;
    }
   else
    {
    inchar-=63;
    inchar=inchar<<Schieber;
    Zaehler+=inchar;
    }
   Schieber+=6;
   }
  while(ch<191);
 }

 if(Zaehler&1)
  {
  Zaehler--;
  Zaehler=0-Zaehler;
  }


 return(Zaehler);
 }



void cmd_pe()

{
 unsigned char ch,fertig=0,penup=0,absolute=0;

 Base32=0;
// fprintf(Debug," neuer Polynom: %5lx:\n",ftell(Quell));
 do        //Flags einlesen...
 {
 ch=getc(Quell);
 switch(ch)
  {
  case ':': {pen=99;printf(":!!");} break;
  case '<': {penup=1;} break;
  case '>': {} break;
  case '=': {absolute=1;} break;
  case '7': {Base32=0;} break;
  case ';': {fertig=1;} break;
  default:
   {
    if(absolute) {neux=neuy=0;};
    neux+=ReadPar(ch);
    ch=getc(Quell);
    neuy-=ReadPar(ch);


    PolyBuf[PolyCount].x=neux;
    PolyBuf[PolyCount].y=neuy;


//    fprintf(Debug,"%6lx %1d %6ld %6ld\n",ftell(Quell),penup,neux,neuy);

    if(!penup)
     {
     PolyCount++;
     if(PolyCount>3990)
      {
      printf("Polygonpuffer berlauf\n");
      exit(0);
      }
     }
    penup=0;
    absolute=0;
   }       break;
  }
 }
 while(!fertig);
}


void PolyOut()
 {
 int a;

 if(PolyCount>1)
 {
 a=0;
 while(PolyCount>a+1)
 {
  Linie(PolyBuf[a].x,PolyBuf[a].y,PolyBuf[a+1].x,PolyBuf[a+1].y);
  a++;
 }
 PolyBuf[0]=PolyBuf[PolyCount-1];
 PolyCount=1;
 }
 }



main(int argc,char **argv)
 {
  char *cp,zielname[300];
  unsigned char ch,cmdbuf[4];
  unsigned int cmd,a;


  if(argc<2)
   {
    printf("Benutzung: HPC <Quelldatei> [Zieldatei] [Faktor]\n"
           "Bsp: HPGL test.plt ziel.cnc 0.984252\n");
    exit(1);
   }
  if(argc<3)
   {
    ch='!';
    strcpy(zielname,"Hallo!");
    strcpy(zielname,argv[1]);
    cp=strrchr(zielname,'.');
    if(cp) strcpy(cp,".cnc");
   }
  else
   {
    strcpy(zielname,argv[2]);
   }
  if(argc>3)
   {
   Faktor=atof(argv[3]);
   }
  else Faktor=1;
  Quell=fopen(argv[1],"rb");
  if(!Quell)
   {
   printf("Dateilesefehler: %s",argv[1]);
   exit(1);
   }
  Ziel=fopen(zielname,"w");
  if(!Ziel)
   {
   printf("Dateischreibfehler: %s",argv[2]);
   exit(1);
   }
//  Debug=fopen("debug.txt","w");
  cmdbuf[0]=cmdbuf[1]=0;
  while(!feof(Quell))
   {
   fp=ftell(Quell);
   ch=fgetc(Quell);
   cmdbuf[0]=cmdbuf[1];
   cmdbuf[1]=ch;
   cmdbuf[2]=0;
   
   if(!strcmp(cmdbuf, "IN")) {
                Init();
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "PU")) {
                if(spur)
                 {
                  Linie(altx,alty,neux,neuy);
                  spur=0;
                 }
                PenDown=0;
                cmdbuf[1]=OptPar();
                cmdbuf[0]=0;
               }
   if(!strcmp(cmdbuf, "PD")) {
                PenDown=1;
                spur=1;
                cmdbuf[1]=OptPar();
                cmdbuf[0]=0;
               }
   if(!strcmp(cmdbuf, "PA")) {
                Relative=0;
                cmdbuf[1]=OptPar();
                cmdbuf[0]=0;
               }
   if(!strcmp(cmdbuf, "PR")) {
                Relative=1;
                cmdbuf[1]=OptPar();
                cmdbuf[0]=0;
               }



   if(!strcmp(cmdbuf, "PP")) {
                fgetc(Quell);
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "WU")) {
                fgetc(Quell);
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "PW")) {
                fgetc(Quell);
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "EP")) {
               PolyOut();
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "PM")) {
                ch=fgetc(Quell);
                switch(ch)
                 {
                 case '0': {
                            PolyBuf[0].x=neux;
                            PolyBuf[0].y=neuy;
                            PolyCount=1;
                           } break;
                 }
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "PE")) {
                cmd_pe();
                cmdbuf[1]=0;
               }
   if(!strcmp(cmdbuf, "SP")) {
                ch=fgetc(Quell);
                if(isdigit(ch))
                 {
                 pen=ch-'0';
                 ch=0;
                 }
                cmdbuf[1]=ch;
               }        
   }
  fclose(Quell);
  fclose(Ziel);
//  fclose(Debug);
  return 0;
 }
