        cpu     8051
        include "stddef51.inc"
        include "useful.inc"


	ajmp	init0



prints: pop    dph
        pop    dpl

prints1:clr    a
        movc   a,@a+dptr
        inc    dptr
        jz     prints2
        acall  txchar
        sjmp   prints1
prints2:
        push   dpl
        push   dph
        ret

print:  macro   arg1
        acall   prints
        db      arg1
        db      0
        endm


init0:

;       Baudrate=Quarz/192/Teiler
;        mov  th1,#-8
;        mov  th1,#-4       ;Teilerfaktor 4 fr 9600 Baud bei 7,372.8 MHz
;        mov  th1,#-3       ;19200 Baud bei 11,059 MHz
;        mov  th1,#-1       ;57600 Baud bei 11,059 MHz
;        mov  th1,#-13      ;4800 Baud bei 12,000 MHz
	mov  th1,#-1	;115200 Baud bei 22,118 MHz		
	mov  tmod,#20h     ;tmr, 8-Bit auto reload
        mov  0a8h,#00h     ;Interrupt gesperrt!
        setb tr1           ;Timer freigeben
	mov  a,pcon
        orl  a,#80h        ;smod=1
        mov  pcon,a
        mov  scon,#72h

        mov     b,#128
        clr     a
        mov     r0,a
init:   mov     @r0,a
        inc     r0
        djnz    b,init
        acall   step


kalt:
        mov     a,#'*'
        acall   txchar
        mov     b,#3
        mov     r0,#60
kalt0:  mov     @r0,#0
        inc     r0
        mov     @r0,#0
        inc     r0
        mov     @r0,#0
        inc      r0
        mov     a,@r0
        anl     a,#0e0h
        orl     a,#010h
        mov     @r0,a
        inc     r0
        djnz    b,kalt0

        mov     b,#20
        clr     a
kalt1:  mov     @r0,a
        inc     r0
        djnz    b,kalt1

loop:
        jnb     ri,loop
        clr     ri
        mov     a,sbuf
        cje     a,#'!',exec
        cje     a,#'q',exit
	cje	a,#'s',sonde
	cje	a,#'?',meldung
        sjmp    loop


exit:   ljmp    0



execx:  ajmp    kalt

exec:   mov     r0,#6ch
        mov     b,#20
exec1:  jnb     ri,exec1
        clr     ri
        mov     a,sbuf
        mov     @r0,a
        inc     r0
        djnz    b,exec1
        mov     a,7ch
        jz      exec11  ;keine Beschleunigungsphase


        ;Beschleunigen
exec2:  acall   step
        mov     b,07eh
exec3:
        nop
        djnz    b,exec3
        mov     b,#4    ;Ausgleich fuer die 8-Bit Schleife
exec4:
        nop
        djnz    b,exec4
        dec     07eh
        djnz    7ch,exec2

        ;Lauf
exec5:  acall   step
        jb      ri,execx
        mov     b,07eh
exec6:
        nop
        djnz    b,exec6

        mov     r1,#78h
        mov     a,@r1   ;steht schon richtig!
        clr     c
        subb    a,#1
        mov     @r1,a
        inc     r1
        mov     a,@r1
        subb    a,#0
        mov     @r1,a
        inc     r1
        mov     a,@r1
        subb    a,#0
        mov     @r1,a
        inc     r1
        mov     a,@r1
        subb    a,#0
        mov     @r1,a
        jnc     exec5

        ;Bremsen
exec7:  acall   step
        mov     b,07eh
exec8:
        nop
        djnz    b,exec8
        mov     b,#4    ;Ausgleich fuer die 8-Bit Schleife
exec9:
        nop
        djnz    b,exec9
        inc     07eh
        djnz    7dh,exec7
        ajmp    kalt


        ;nur Lauf
exec11: acall   step
        jb      ri,execx
        mov     b,07eh
exec12:
        nop
        djnz    b,exec12

        mov     r1,#78h
        mov     a,@r1   ;steht schon richtig!
        clr     c
        subb    a,#1
        mov     @r1,a
        inc     r1
        mov     a,@r1
        subb    a,#0
        mov     @r1,a
        inc     r1
        mov     a,@r1
        subb    a,#0
        mov     @r1,a
        inc     r1
        mov     a,@r1
        subb    a,#0
        mov     @r1,a
        jnc     exec11
        ajmp    kalt







step:
        mov     r0,#60h
        mov     r1,#6ch

        mov     a,@r0
        add     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1

        mov     a,@r0
        add     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1

        mov     a,@r0
        add     a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a
        inc     r0
        inc     r1
        mov     a,@r0
        addc    a,@r1
        mov     @r0,a



        mov     a,63h
        anl     a,#11100000b
        rr      a
        rr      a
        rr      a
        mov     r0,a
        mov     a,67h
        anl     a,#11100000b
        orl     a,r0
        rr      a
        rr      a
        mov     r0,a
        mov     a,6bh
        mov     c,acc.5
        anl     a,#11000000b
        orl     a,r0
        cpl     a
        cpl     c
        mov     p1,a
        mov     p3.7,c
        ret





txchar: jnb     ti,txchar
        clr     ti
        mov     sbuf,a
        ret



sonde:
        clr     a
        mov     r0,#6ch
        mov     b,#11          ;mov x und y , z untere 2 Bytes loeschen
sond0:  mov     @r0,a
        inc     r0
        djnz    b,sond0

        mov     @r0,#-20h      ;z HiByte: ein Halbschritt je Durchlauf
        inc     r0

        mov     b,#4           ;Schrittzaehler loeschen
sond1:  mov     @r0,a
        inc     r0
        djnz    b,sond1


sond2:
        jnb     p3.4,sondx
        acall   step
        mov     b,#0
sond3:  nop
        nop
        nop
        nop
        nop
        nop
        djnz    b,sond3

        mov     a,78h
        add     a,#1
        mov     78h,a

        mov     a,79h
        addc    a,#0
        mov     79h,a

        mov     a,7ah
        addc    a,#0
        mov     7ah,a

        mov     a,79h
        clr     c
        subb    a,#8    ;2048 Halbschritte; etwa 5 mm sollten reichen
        jc      sond2

sondx:
        mov     a,78h
        acall   txchar
        mov     a,79h
        acall   txchar
	ajmp	kalt

meldung:

	;-----------------
	print "Schrittmotosteuerung 8051 (c) Ingo Wendler "+DATE
	ajmp	kalt
