
//---------------------------------------------------------------------------
long int Scan(int x,int y)
 {
 int breit,hoch;
 breit=(xmax-xmin-200)*10;  //2,5 mm linker + 2,5 mm rechter Rand
 hoch=(ymax-ymin-80)*10;    //2 mm oberer Rand
 x=x*4000+1000;          //quadranten in doppelschritte
 y*=4000;
 if (y<800) y=800; //2 mm unterer Rand
 if (y>hoch) y=hoch;
 if (x<1000) x=1000;
 if (x>breit) x=breit;
 StepMoveTo(x,y,0,200,120);
 hoch=StepSonde();
 StepMoveTo(ActX,ActY,0,200,120);  //wieder hoch
 return(hoch);
 }
//---------------------------------------------------------------------------

BOOL WINAPI Just_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   static int JustFlag=0;
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       StepOpen(Dialog1.Comport);
       SendMessage(hWnd,WM_SETICON,(WPARAM) ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
       SendMessage(GetDlgItem(hWnd,IDC_X),WM_SETTEXT,0,(LPARAM) "0");
       SendMessage(GetDlgItem(hWnd,IDC_Y),WM_SETTEXT,0,(LPARAM) "0");
       SendMessage(GetDlgItem(hWnd,IDC_Z),WM_SETTEXT,0,(LPARAM) "0");       
      }
      break;
      
     case WM_DESTROY:
      {
       StepClose();
      }
       
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       
       case IDC_OK:
        {
         ActX=1000;     //2,5 mm
	 ActY=0;
	 ActZ=0;
         EndDialog(hWnd,0);
         /* Eingegebene Werte speichern */
         return 0;
        }

       case IDC_CANCEL:
        {
         ActX=1000;     //2,5 mm
	 ActY=0;
	 ActZ=0;
         EndDialog(hWnd,1);
         /* Eingegebene Werte speichern */
         return 0;
        }
        
       case IDC_X:
        {
         if((HIWORD(wParam)==EN_CHANGE)&&(!JustFlag))
          {
          JustFlag=1;
          SendMessage(GetDlgItem(hWnd,IDC_Y),WM_SETTEXT,0,(LPARAM) "0");
          SendMessage(GetDlgItem(hWnd,IDC_Z),WM_SETTEXT,0,(LPARAM) "0");
          JustFlag=0;
          }
        return 0;
        }
        
       case IDC_Y:
        {
         if((HIWORD(wParam)==EN_CHANGE)&&(!JustFlag))
          {
          JustFlag=1;
          SendMessage(GetDlgItem(hWnd,IDC_X),WM_SETTEXT,0,(LPARAM) "0");
          SendMessage(GetDlgItem(hWnd,IDC_Z),WM_SETTEXT,0,(LPARAM) "0");
          JustFlag=0;
          }
        return 0;
        }
        
       case IDC_Z:
        {
         if((HIWORD(wParam)==EN_CHANGE)&&(!JustFlag))
          {
          JustFlag=1;
          SendMessage(GetDlgItem(hWnd,IDC_Y),WM_SETTEXT,0,(LPARAM) "0");
          SendMessage(GetDlgItem(hWnd,IDC_X),WM_SETTEXT,0,(LPARAM) "0");
          JustFlag=0;
          }
        return 0;
        }

       case IDC_EXEC:
        {
         double x,y,z;
         int i;
         char st1[150];
         SendMessage(GetDlgItem(hWnd,IDC_X),WM_GETTEXT,40,(LPARAM) st1);
         sscanf(st1,"%LE",&x);
         SendMessage(GetDlgItem(hWnd,IDC_Y),WM_GETTEXT,40,(LPARAM) st1);
         sscanf(st1,"%LE",&y);
         SendMessage(GetDlgItem(hWnd,IDC_Z),WM_GETTEXT,40,(LPARAM) st1);
         sscanf(st1,"%LE",&z);

         StepRun(x*MaschKonst,y*MaschKonst,
                 z*MaschKonst,200,100);
        return 0;
        }

       case IDC_VERMESS:
        {
	signed long int a,b,x,y;
	signed long c,hoch,breit;
	char st1[200];

	breit=(xmax+200-xmin)/400;    //HPGL Schritte in zentimeter
	hoch=(ymax+200-ymin)/400;
	if((breit>0)&&(hoch>0))
	 {
	 ActX=1000;ActY=0;ActZ=0;
	 for (y=0;y<hoch+1;y++)
	 {
	  if(y&1)
	  {
	  for (x=breit;x>=0;x--)
	   {
	   Gebirge[x][y]=Scan(x,y);
	   }
	  }
	  else
	  {
	   for (x=0;x<breit+1;x++)
	   {
	   Gebirge[x][y]=Scan(x,y);
	   }
	  }
	 }
	 StepMoveTo(1000,0,0,200,120); //nach Hause
	 }
	else MessageBox(hWnd,"Keine Zeichnung geladen!","Meldung",MB_OK);
        return 0;
        }
        
       case IDC_AUTOJUST:
        {
	ActX=1000;ActY=0;ActZ=0;
	StepMoveTo(ActX,ActY+1000,ActZ,200,120);
	StepSonde();
	ActZ=-200;
	StepMoveTo(ActX,ActY,0,200,120);  //wieder hoch
	StepMoveTo(ActX,ActY-1000,ActZ,200,120);
        return 0;
        }

       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,1);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }


