#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "step.h"
#include "main.h"

struct {
	 char Comport[20];
	 char Bohrtiefe[20];
	 char Fraestiefe[20];
	} Dialog1;

unsigned long int MaschKonst=400; /* Halbschritte je Milimeter*/

HINSTANCE g_hInst;
HWND g_hwndStatus;
HWND g_hWnd;

char ParamStr[300];
unsigned long Gebirge[14][20];
unsigned long BreakFlag=0,IntFlag=0;
signed long X1,Y1,X2,Y2,
            xmin,xmax,ymin,ymax,Layer;
char WorkFileName[300],TempFileName[300],TempFile=0,UsedLayers[20];
int AktLayers[10];

char LayerNames[10][100];

float Scale=1;


int  Farben[]=
  {
  /*   bbggrr */
   0x00000000,  //schwarz
   0x00000000,  //schwarz
   0x000000ff,  //rot
   0x0000ff00,  //grn
   0x00007f7f,  //gelb
   0x00ff0000,  //blau
   0x007f007f,  //magenta
   0x007f7f00,  //cyan
   0x00000000,  //schwarz
   0x00404040,  //grau
   0x00000000,  //schwarz
   };


#include "just.cpp"
#include "dialog1.cpp"
#include "run.cpp"
//---------------------------------------------------------------------------
int MyFileOpen(char *FileName)
 {
 FILE *Datei;
 int i;
 char st1[600],*cp,CnvPath[300];
 char Name[300];
 unsigned long a=0;
 ymin=xmin=+2000000000;
 ymax=xmax=-2000000000;
  {
  for(a=0;a<9;a++) 
   {
   UsedLayers[a]='-';
   AktLayers[a]=0;
   sprintf(LayerNames[a],"Stift %d",a);
   }
  if (TempFile)
   {
   remove(TempFileName);
   TempFile=0;
   }
   cp=strrchr(FileName,'.');
   if((strncmp(cp,".CNC",3)&&(strncmp(cp,".cnc",3))))
    {
     strcpy(TempFileName,ParamStr);
     strcpy(CnvPath,ParamStr);
     strcat(TempFileName,".cnc");
     cp=strrchr(CnvPath,'\\');
     if(cp) *cp=0;
     strcat(CnvPath,"\\hpgl.exe");
     sprintf(st1,"%s %s %s",CnvPath,FileName,TempFileName);
     system(st1);
     TempFile=1;
     /* Versuchen, die Textdatei mit den Stiftnamen einzulesen*/
     strcpy(st1,FileName);
     cp=strrchr(st1,'.');
     strcpy(cp,".txt");
     cp=st1;
     if(st1[0]=='"') cp++;
     Datei=fopen(cp,"r");
     if(Datei)
      {
      while(!feof(Datei))
       {
       fgets(st1,200,Datei);
       cp=strstr(st1," Depth");
       if(cp) *cp=0;
       sscanf(st1,"T%d;",&i);
       cp=strchr(st1,' ');
       if(!cp) cp=st1; else cp++;
       strcpy(LayerNames[i],cp);
       }
      fclose(Datei);
      }
    }
  else 
   {
   if(FileName[0]=='"')
    {
    FileName[strlen(FileName)-1]=0;
    strcpy(TempFileName,FileName+1);
    }
   else strcpy(TempFileName,FileName);
   }

  Datei=fopen(TempFileName,"r");
  if(!Datei)
   {
   SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) "keine Datei");
   }
  else
  {
  while(!feof(Datei))
   {
    fgets(st1,150,Datei);
    sscanf(st1+1,"%ld %ld %ld %ld %ld",&Layer,&X1,&Y1,&X2,&Y2);
    UsedLayers[Layer]='0'+Layer;
    if((Layer<9)&&(Layer>0))
    a++;
     {
     if(X1>xmax) xmax=X1;
     if(X1<xmin) xmin=X1;
     if(Y1>ymax) ymax=Y1;
     if(Y1<ymin) ymin=Y1;
     if(st1[0]=='L')
      {
      if(X2>xmax) xmax=X2;
      if(X2<xmin) xmin=X2;
      if(Y2>ymax) ymax=Y2;
      if(Y2<ymin) ymin=Y2;
      }
     }
   }
   fclose(Datei);
  }
  strcpy(WorkFileName,TempFileName);
  UsedLayers[9]=0;
  sprintf(st1,"%ld Elemente, %.2f mm hoch, %.2f mm breit Stifte %s",
                            a,(float)(ymax-ymin)/40,
                              (float)(xmax-xmin)/40,UsedLayers);
  SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 0,(LPARAM) st1);

  strcpy(Name,FileName);
  strcat(Name," - Ingos FrsBohrPlotter");
  SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM) Name);
  }
  return 0;
 }






LRESULT CALLBACK WndProc (HWND hWnd, UINT uiMessage,
					WPARAM wParam, LPARAM lParam)
	{
	int nParts=3;

	  switch(uiMessage)
	  {
	   case WM_DESTROY:
	    {
            /* INIFile schreiben */
            char st1[300];
            FILE *Datei;
            strcpy(st1,ParamStr);
            strcat(st1,".ini");
            Datei=fopen(st1,"w");
            if(Datei)
            {
             fprintf(Datei,"%s\n",Dialog1.Comport);
             fprintf(Datei,"%s\n",Dialog1.Bohrtiefe);
             fprintf(Datei,"%s\n",Dialog1.Fraestiefe);
             fclose(Datei);
            }      

	       if (TempFile)
		{
		remove(TempFileName);
		TempFile=0;
		}
	     PostQuitMessage(0);
	     return 0;
	    } 
	   case WM_CREATE:
             {	     
	     /* StatusBar erzeugen */

		int nWidth,i,*lpParts;
		char st1[300],*cp;
		int x,y;
		FILE *Datei;
		RECT rcClient;
		HANDLE hloc;
		g_hWnd=hWnd;
		g_hwndStatus = CreateWindowEx( 
			0,                      // no extended styles 
			STATUSCLASSNAME,        // name of status window class 
			(LPCTSTR) NULL,         // no text when first created 
			SBARS_SIZEGRIP |        // includes a sizing grip 
			WS_VISIBLE |
			WS_CHILD,               // creates a child window 
			0, 0, 0, 0,             // ignores size and position 
			hWnd,              	// handle to parent window 
			(HMENU) 0,       	// child window identifier 
			g_hInst,                // handle to application instance 
			NULL);                  // no window creation data 
 
		GetClientRect(hWnd, &rcClient); 
		hloc = LocalAlloc(LHND, sizeof(int) * nParts); 
		lpParts = (int*)LocalLock(hloc); 
		nWidth = rcClient.right / nParts; 
		for (i = 0; i < nParts; i++) 
		{ 
		 lpParts[i] = nWidth; 
		 nWidth += nWidth; 
		} 
		SendMessage(g_hwndStatus, SB_SETPARTS, (WPARAM) nParts,(LPARAM) lpParts); 
		LocalUnlock(hloc); 
		LocalFree(hloc); 
		for(x=0;x<14;x++)
		{
		for(y=0;y<20;y++) Gebirge[x][y]=200;
		}
		/* Datei in der Kommandozeile angegeben? */
		strcpy(st1,GetCommandLine());
		cp=st1;
		if(*cp=='"') 
		 {
		 cp=strchr(cp+1,'"'); /*zweites Gnsefsschen*/
		 if(!cp) return 0;
		 cp++;
		 }
		else
		 {
		 cp=strchr(cp,' ');
		 } 
		if (cp)
		  {
		   if(*cp==' ') 
		    {
		    cp++;
		    if(strlen(cp)>3)
		    MyFileOpen(cp);
		    }
		  }

	       strcpy(Dialog1.Comport,"com1"); 
	       strcpy(Dialog1.Bohrtiefe,"10");
	       strcpy(Dialog1.Fraestiefe,"10");
		/* Versuchen INIFile einzulesen */
		strcpy(st1,ParamStr);
		strcat(st1,".ini");
		Datei=fopen(st1,"r");
		if(Datei)
		{
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Comport,st1);
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Bohrtiefe,st1);
		if(fscanf(Datei,"%s\n",st1)==1) strcpy(Dialog1.Fraestiefe,st1);
		fclose (Datei);
		}
	       
	     return 0;
	     }

	    case WM_SIZE:
	     {
             int i,inc,width[5];
             char puffer[30];
	     RECT rcClient;
             GetClientRect(hWnd, &rcClient);
             width[0] = 350;
             width[1] = 400;
             width[2] = rcClient.right;
              
             SendMessage(g_hwndStatus, SB_SETPARTS, (WPARAM) 3,(LPARAM) width);
//             wsprintf(puffer,"%dx%d",rcClient.right,rcClient.bottom);
       
             //einfach an den StatusBar weitergeben
             SendMessage(g_hwndStatus,WM_SIZE,wParam,lParam);
             SendMessage(hWnd,WM_PAINT,0,0);
	     return 0;
	     } 
	      
	    case WM_PAINT:
	     {
      		PAINTSTRUCT ps;
      		HDC hdc;
      		HPEN pens[10],penalt;
      		HBRUSH grau,weiss,brushalt;
		RECT rcClient;
                char puffer[30];

		FILE *Datei;
		char st1[200];
		signed long SizeX,SizeY,Di;
		float ScaleX,ScaleY;
		int X1,Y1,X2,Y2,a,LayAll=1;

		hdc=GetDC(hWnd);
		
		for(a=0;a<10;a++) pens[a]=CreatePen(PS_SOLID,1,Farben[a]);
      		grau=CreateSolidBrush(RGB(200,200,200));
      		weiss=CreateSolidBrush(RGB(255,255,255));
      		penalt=(HPEN)SelectObject(hdc,pens[0]);      
//      		brushalt=(HBRUSH)SelectObject(hdc,brush);      
		GetClientRect(hWnd, &rcClient);
		rcClient.bottom-=18;		/* Statusleiste aussparen */
		FillRect(hdc,&rcClient,grau); 	/* gesamtes Fenster grau machen */


		//ist berhaupt schon eine Datei geladen?
		if((xmax>xmin)&&(ymax>ymin))
		{
		 /*Testen ob irgendein Stift aktiv*/
		 for(a=1;a<9;a++) if(AktLayers[a]) LayAll=0;
		 Datei=fopen(WorkFileName,"r");
		 if(Datei)
		 {
		  RECT Blatt;
		  SizeX=xmax-xmin;
		  SizeY=ymax-ymin;
		  ScaleX=(float)(rcClient.right-rcClient.left)/(float)SizeX;
		  ScaleY=(float)(rcClient.bottom-rcClient.top)/(float)SizeY;
		  if(ScaleY>ScaleX) Scale=ScaleX;
		  else Scale=ScaleY;

                  Blatt.left=0;
                  Blatt.right=SizeX*Scale;
                  Blatt.top=0;
                  Blatt.bottom=SizeY*Scale;
       		  FillRect(hdc,&Blatt,weiss);
		  while(!feof(Datei))
		  {
		   fgets(st1,150,Datei);
		   sscanf(st1+1,"%ld %ld %ld %ld %ld",&Layer,&X1,&Y1,&X2,&Y2);
		   Layer&=7;
                   if(st1[0]=='L')
		   {
		    if(((AktLayers[Layer])||(LayAll))
		       &&(X1>(xmin+40)) && (X1<(xmax-40))
		       &&(X2>(xmin+40)) && (X2<(xmax-40)))

		    {
		     X1=(X1-xmin)*Scale;
		     Y1=(-Y1+ymax)*Scale;
		     X2=(X2-xmin)*Scale;
		     Y2=(-Y2+ymax)*Scale;
			//      if(!Layer) Layer++;
//                     Canvas->Pen->Color=Stifte[Layer];
		     if((X1==X2)&&(Y1==Y2))
		         SetPixel(hdc,X1,Y1,Farben[Layer]); //nur ein Punkt
		     else
			{
			 SelectObject(hdc,pens[Layer]);
      		         MoveToEx(hdc,X1,Y1,0);
      		         LineTo(hdc,X2,Y2);
			}
                     }
                    }
		  }
		  fclose(Datei);
		 }
		}


//		SelectObject(hdc,brushalt);
		SelectObject(hdc,penalt);
      
      		for(a=0;a<8;a++) DeleteObject(pens[a]);
      		DeleteObject(grau);
      		DeleteObject(weiss);
     
		ReleaseDC(hWnd,hdc);

      		BeginPaint(hWnd,&ps);      
      		EndPaint(hWnd,&ps);

                SendMessage(g_hwndStatus,SB_SETTEXT,(WPARAM) 1,(LPARAM) Dialog1.Comport);
		return 0;
	     }	


	   case WM_COMMAND:
	     switch (LOWORD(wParam))
	     {
	     case CM_DATEIOEFFNEN:
	      {
	       OPENFILENAME ofn;
               char FileName[300];
               FileName[0]=0;           
               ZeroMemory(&ofn,sizeof(ofn));
               ofn.lStructSize=sizeof(ofn);
	       ofn.hwndOwner=hWnd;
	       ofn.lpstrFile=FileName;
	       ofn.nMaxFile=290;
	       ofn.lpstrTitle="Datei whlen!";
	       ofn.Flags=OFN_FILEMUSTEXIST;
	             
               if(GetOpenFileName(&ofn))
                {
                 MyFileOpen(FileName);
                }

	      }
	      return 0;
	      
	     case CM_DATEIBEENDEN:
	       SendMessage(hWnd,WM_CLOSE,0,0);
	       return 0;
	       
	     case CM_DIALOG1:
	       DialogBox(g_hInst,MAKEINTRESOURCE(IDD_DIALOG1),hWnd,Dialog1_DlgProc);
	       SendMessage(hWnd,WM_PAINT,0,0); 
	       return 0;
	       
	     case CM_JUST:
	      {
	       DialogBox(g_hInst,MAKEINTRESOURCE(IDD_JUST),hWnd,Just_DlgProc);
	       return;
	      } 

	     case CM_BOHREN:
	      {
	      DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_RUN),hWnd,Run_DlgProc,
	                     (LPARAM) CM_BOHREN);
	      return 0;
	      }
	      
	     case CM_FRAESEN:
	      {
	      DialogBoxParam(g_hInst,MAKEINTRESOURCE(IDD_RUN),hWnd,Run_DlgProc,
	                     (LPARAM) CM_FRAESEN);
	      return 0;
	      }

             case CM_REFRESH:
              {
              SendMessage(hWnd,WM_PAINT,0,0);
              return 0;
              }
	     }
            return 0;
	   default:
	     return DefWindowProc (hWnd, uiMessage, wParam, lParam);  
	  }
	}



int APIENTRY WinMain(HINSTANCE hInstance,
			HINSTANCE hPrevInstance,
			LPSTR	lpCmdLine,
			int	nCmdShow)
	{
	g_hInst=hInstance;
	InitCommonControls();
	
	
	char *cp,st1[200];
	/* Programmpfad aus der Kommandozeile auswerten */
	strcpy(st1,GetCommandLine());
	if(st1[0]=='"')
	 {
	 /* schliessendes Gnsefchen entfernen */
	 cp=strchr(st1+1,'"');
	 if(cp) *cp=0;
	 /* Endung entfernen */
	 cp=strrchr(st1+1,'.');
	 if(cp) *cp=0;
	 strcpy(ParamStr,st1+1);
	 }
	else
	 {
	 cp=strchr(st1,' ');
	 if (cp) *cp = 0; /* mehr als ein Parameter */
	 cp=strrchr(st1,'.');
	 if (cp) *cp = 0; /* evtl Endung entfernen */
	 GetCurrentDirectory(280,ParamStr);
	 strcat(ParamStr,"\\");
	 strcat(ParamStr,st1);
	 }
	
	
	WNDCLASS WndClass;
	WndClass.style =CS_OWNDC | CS_VREDRAW | CS_HREDRAW;
	WndClass.cbClsExtra=0;	
	WndClass.cbWndExtra=0;
	WndClass.lpfnWndProc=WndProc;
	WndClass.hInstance=hInstance;	
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);	
	WndClass.hCursor=0; /* LoadCursor(hInstance,MAKEINTRESOURCE(IDC_CURSOR2)); */
	WndClass.hIcon=LoadIcon(hInstance,	MAKEINTRESOURCE(IDI_ICON1));
	WndClass.lpszMenuName=MAKEINTRESOURCE(IDM_MENU1);
	WndClass.lpszClassName="WinProg";
	RegisterClass(&WndClass);
	
	g_hWnd=CreateWindow("WinProg","Winplot",WS_OVERLAPPEDWINDOW,
				0,0,400,400,NULL,NULL,hInstance,NULL);
	ShowWindow(g_hWnd,nCmdShow);
	UpdateWindow((g_hWnd));
	
	MSG Message;
	while (GetMessage(&Message,NULL,0,0))
	 {
	 DispatchMessage(&Message);
	 TranslateMessage(&Message);
	 }
	 return(Message.wParam);	 
      }
