
BOOL WINAPI Dialog1_DlgProc(HWND hWnd,
                    UINT wMsg,
                    WPARAM wParam,
                    LPARAM lParam)
   {
   switch (wMsg)
     {
     case WM_INITDIALOG:
      {
       int i;
       char st1[10];
       HANDLE ComHandle;
       SendMessage(hWnd,WM_SETICON,(WPARAM) ICON_BIG,(LPARAM)LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1)));
	/* Eingabefelder initialisieren */
       SendMessage(GetDlgItem(hWnd,IDC_COMPORT),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Comport);
       SendMessage(GetDlgItem(hWnd,IDC_BOHRTIEFE),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Bohrtiefe);
       SendMessage(GetDlgItem(hWnd,IDC_FRAESTIEFE),WM_SETTEXT,(WPARAM) 0,(LPARAM) Dialog1.Fraestiefe);
       SetFocus(GetDlgItem(hWnd,IDC_COMPORT));
	
       for(i=1;i<10;i++)
	{
	sprintf(st1,"com%d",i);
	ComHandle=CreateFile(st1,
                     GENERIC_READ|GENERIC_WRITE,    //beabsichigter Zugriff
                     0,                             //kein sharing
                     0,                             //security attributes
                     OPEN_EXISTING,
                     FILE_ATTRIBUTE_NORMAL,
                     0);
	if(ComHandle!=INVALID_HANDLE_VALUE)
	 {
	 SendMessage(GetDlgItem(hWnd,IDC_COMPORT),CB_ADDSTRING,0,(LPARAM) st1);
	 CloseHandle(ComHandle);
	 ComHandle=INVALID_HANDLE_VALUE;
	 }
        }
	SendMessage(GetDlgItem(hWnd,IDC_LAYER),CB_ADDSTRING,0,(LPARAM) "alle");

       for(i=1;i<9;i++)
        {
        /*Checkboxen der Layer initialisieren*/
        SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),WM_SETTEXT,(WPARAM) 0,(LPARAM) LayerNames[i]);
        if(AktLayers[i])
         SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),BM_SETCHECK,(WPARAM) BST_CHECKED,(LPARAM) 0);
        else
         SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),BM_SETCHECK,(WPARAM) BST_UNCHECKED,(LPARAM) 0);
        
         if(UsedLayers[i]!='-')
	  {
          EnableWindow(GetDlgItem(hWnd,IDC_LAYER1+i-1),TRUE);
          sprintf(st1,"Stift %d",i);
	  SendMessage(GetDlgItem(hWnd,IDC_LAYER),CB_ADDSTRING,0,(LPARAM) st1);
	  }
        } 
      }
      break;
     case WM_COMMAND:
      {
      switch (LOWORD(wParam))
       {
       case IDC_PUSHBUTTON_OK:
        {
         char st1[20];
         int i;
         /* Eingegebene Werte speichern */
	  SendMessage(GetDlgItem(hWnd,IDC_COMPORT),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Comport);
	  SendMessage(GetDlgItem(hWnd,IDC_LAYER),WM_GETTEXT,(WPARAM) 16,(LPARAM) st1);
	  SendMessage(GetDlgItem(hWnd,IDC_BOHRTIEFE),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Bohrtiefe);
	  SendMessage(GetDlgItem(hWnd,IDC_FRAESTIEFE),WM_GETTEXT,(WPARAM) 16,(LPARAM) Dialog1.Fraestiefe);

          for(i=1;i<9;i++)
          {
          /*Checkboxen der Layer lesen*/
          if(SendMessage(GetDlgItem(hWnd,IDC_LAYER1+i-1),BM_GETCHECK,(WPARAM) 0,(LPARAM) 0)==BST_CHECKED) AktLayers[i]=1;
          else AktLayers[i]=0;
          } 
         EndDialog(hWnd,0);
        }
        break;      
       }  
      }
     break;
     case WM_SYSCOMMAND:
      {
       switch(wParam)
        {
         case SC_CLOSE:
         {
         EndDialog(hWnd,0);
         }
         break;
        }
      }
      break;  
     }
   return FALSE; 
   }


